// Library = EvoApprox 12x12
// Circuit = mul12x12_243
// Area   (45) = 125
// Delay  (45) = 0.590
// Power  (45) = 0.04
// MAE = 436937.40000
// MSE = 278893445076.70001
// MRE = 256.13 %
// WCE = 1673483
// WCRE = 52966300 %
// EP = 100.0 %
module mul12x12_243(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_705, n_704, n_1748, n_45, n_44, n_47, n_46, n_41, n_40, n_43;
  wire n_42, n_49, n_48, n_386, n_1872, n_710, n_30, n_31, n_32, n_33;
  wire n_34, n_35, n_36, n_37, n_38, n_39, n_1745, n_1744, n_798, n_799;
  wire n_392, n_390, n_391, n_394, n_1834, n_662, n_664, n_665, n_668, n_669;
  wire n_23, n_22, n_21, n_20, n_27, n_26, n_25, n_24, n_802, n_803;
  wire n_29, n_28, n_2038, n_804, n_1836, n_659, n_658, n_183, n_182, n_2;
  wire n_18, n_19, n_16, n_17, n_14, n_15, n_12, n_13, n_10, n_11;
  wire n_521, n_520, n_306, n_334, n_335, n_336, n_358, n_81, n_80, n_1857;
  wire n_1856, n_362, n_592, n_360, n_364, n_2044, n_2040, n_2043, n_2042, n_74;
  wire n_75, n_593, n_800, n_801, n_69, n_68, n_62, n_518, n_750, n_751;
  wire n_756, n_757, n_754, n_510, n_758, n_514, n_515, n_516, n_517, n_8;
  wire n_9, n_4, n_5, n_6, n_7, n_0, n_1, n_307, n_3, n_761;
  wire n_760;
  assign n_0 = A[0];
  assign n_1 = A[0];
  assign n_2 = A[1];
  assign n_3 = A[1];
  assign n_4 = A[2];
  assign n_5 = A[2];
  assign n_6 = A[3];
  assign n_7 = A[3];
  assign n_8 = A[4];
  assign n_9 = A[4];
  assign n_10 = A[5];
  assign n_11 = A[5];
  assign n_12 = A[6];
  assign n_13 = A[6];
  assign n_14 = A[7];
  assign n_15 = A[7];
  assign n_16 = A[8];
  assign n_17 = A[8];
  assign n_18 = A[9];
  assign n_19 = A[9];
  assign n_20 = A[10];
  assign n_21 = A[10];
  assign n_22 = A[11];
  assign n_23 = A[11];
  assign n_24 = B[0];
  assign n_25 = B[0];
  assign n_26 = B[1];
  assign n_27 = B[1];
  assign n_28 = B[2];
  assign n_29 = B[2];
  assign n_30 = B[3];
  assign n_31 = B[3];
  assign n_32 = B[4];
  assign n_33 = B[4];
  assign n_34 = B[5];
  assign n_35 = B[5];
  assign n_36 = B[6];
  assign n_37 = B[6];
  assign n_38 = B[7];
  assign n_39 = B[7];
  assign n_40 = B[8];
  assign n_41 = B[8];
  assign n_42 = B[9];
  assign n_43 = B[9];
  assign n_44 = B[10];
  assign n_45 = B[10];
  assign n_46 = B[11];
  assign n_47 = B[11];
  assign n_48 = ~(n_12 ^ n_12);
  assign n_49 = n_48;
  assign n_62 = ~n_49;
  assign n_68 = ~(n_44 & n_62);
  assign n_69 = n_68;
  assign n_74 = ~n_62;
  assign n_75 = n_74;
  assign n_80 = ~n_49;
  assign n_81 = n_80;
  assign n_182 = ~n_75;
  assign n_183 = n_182;
  assign n_306 = n_22 & n_40;
  assign n_307 = n_306;
  assign n_334 = n_20 & n_42;
  assign n_335 = n_334;
  assign n_336 = n_22 & n_42;
  assign n_358 = n_16 & n_20;
  assign n_360 = n_18 & n_44;
  assign n_362 = n_20 & n_44;
  assign n_364 = n_22 & n_44;
  assign n_386 = n_16 & n_46;
  assign n_390 = n_18 & n_46;
  assign n_391 = n_390;
  assign n_392 = n_20 & n_46;
  assign n_394 = n_22 & n_46;
  assign n_510 = n_42 & n_358;
  FAX1 tmp85(.YS(n_514), .YC(n_515), .A(n_335), .B(n_360), .C(n_386));
  FAX1 tmp86(.YS(n_516), .YC(n_517), .A(n_336), .B(n_362), .C(n_391));
  assign n_518 = n_364 & n_392;
  HAX1 tmp88(.YS(n_520), .YC(n_521), .A(n_364), .B(n_392));
  assign n_592 = ~n_81;
  assign n_593 = n_592;
  FAX1 tmp91(.YS(n_658), .YC(n_659), .A(n_183), .B(n_516), .C(n_515));
  assign n_662 = n_520 & n_517;
  HAX1 tmp93(.YS(n_664), .YC(n_665), .A(n_520), .B(n_517));
  HAX1 tmp94(.YS(n_668), .YC(n_669), .A(n_394), .B(n_518));
  assign n_704 = n_18 & n_510;
  assign n_705 = n_704;
  assign n_710 = n_307;
  FAX1 tmp98(.YS(n_750), .YC(n_751), .A(n_658), .B(n_710), .C(n_705));
  assign n_754 = n_664 & n_659;
  HAX1 tmp100(.YS(n_756), .YC(n_757), .A(n_664), .B(n_659));
  assign n_758 = n_668 & n_662;
  HAX1 tmp102(.YS(n_760), .YC(n_761), .A(n_668), .B(n_662));
  assign n_798 = n_750;
  assign n_799 = n_798;
  HAX1 tmp105(.YS(n_800), .YC(n_801), .A(n_756), .B(n_751));
  HAX1 tmp106(.YS(n_802), .YC(n_803), .A(n_760), .B(n_754));
  assign n_804 = n_669 | n_758;
  assign n_1744 = n_801;
  assign n_1745 = n_1744;
  assign n_1748 = n_1745;
  assign n_1834 = n_802 & n_801;
  assign n_1836 = n_803 | n_1834;
  assign n_1856 = n_1836;
  assign n_1857 = n_1856;
  assign n_1872 = n_1857;
  assign n_2038 = n_799;
  assign n_2040 = n_800;
  HAX1 tmp118(.YS(n_2042), .YC(n_2043), .A(n_802), .B(n_1748));
  assign n_2044 = n_804 | n_1872;
  assign O[0] = n_81;
  assign O[1] = n_28;
  assign O[2] = n_22;
  assign O[3] = n_80;
  assign O[4] = n_42;
  assign O[5] = n_4;
  assign O[6] = n_30;
  assign O[7] = n_8;
  assign O[8] = n_593;
  assign O[9] = n_182;
  assign O[10] = n_75;
  assign O[11] = n_32;
  assign O[12] = n_69;
  assign O[13] = n_20;
  assign O[14] = n_46;
  assign O[15] = n_40;
  assign O[16] = n_81;
  assign O[17] = n_62;
  assign O[18] = n_38;
  assign O[19] = n_48;
  assign O[20] = n_2038;
  assign O[21] = n_2040;
  assign O[22] = n_2042;
  assign O[23] = n_2044;
endmodule