// Library = EvoApprox 12x12
// Circuit = mul12x12_258
// Area   (45) = 35
// Delay  (45) = 0.210
// Power  (45) = 0.01
// MAE = 991421.50000
// MSE = 1435965098588.69995
// MRE = 500.65 %
// WCE = 3279124
// WCRE = 105192700 %
// EP = 100.0 %
module mul12x12_258(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_1430, n_238, n_715, n_353, n_1435, n_377, n_190, n_191, n_193, n_23;
  wire n_22, n_21, n_20, n_27, n_39, n_875, n_916, n_1438, n_917, n_164;
  wire n_89, n_66, n_65, n_442, n_445, n_443, n_1522, n_1521, n_1520, n_714;
  wire n_915, n_448, n_441, n_8, n_9, n_717, n_4, n_5, n_6, n_7;
  wire n_0, n_1, n_2, n_3, n_872, n_716, n_34, n_876, n_18, n_19;
  wire n_16, n_17, n_14, n_15, n_12, n_13, n_10, n_11, n_1421, n_117;
  wire n_177, n_178, n_47, n_54, n_1378, n_1074, n_447;
  assign n_0 = A[0];
  assign n_1 = A[1];
  assign n_2 = A[2];
  assign n_3 = A[3];
  assign n_4 = A[4];
  assign n_5 = A[5];
  assign n_6 = A[6];
  assign n_7 = A[7];
  assign n_8 = A[8];
  assign n_9 = A[9];
  assign n_10 = A[10];
  assign n_11 = A[11];
  assign n_12 = B[0];
  assign n_13 = B[1];
  assign n_14 = B[2];
  assign n_15 = B[3];
  assign n_16 = B[4];
  assign n_17 = B[5];
  assign n_18 = B[6];
  assign n_19 = B[7];
  assign n_20 = B[8];
  assign n_21 = B[9];
  assign n_22 = B[10];
  assign n_23 = B[11];
  assign n_27 = n_6 ^ n_6;
  assign n_34 = n_27 & n_6;
  assign n_39 = n_34;
  assign n_47 = ~n_39;
  assign n_54 = n_15 & n_34;
  assign n_65 = ~(n_47 | n_34);
  assign n_66 = ~n_65;
  assign n_89 = ~(n_21 | n_47);
  assign n_117 = ~(n_65 | n_54);
  assign n_164 = n_11 & n_21;
  assign n_177 = n_10 & n_23;
  assign n_178 = n_11 & n_22;
  assign n_190 = n_9 & n_23;
  assign n_191 = n_10 & n_23;
  assign n_193 = n_11 & n_23;
  assign n_238 = ~n_47;
  assign n_353 = n_11 & n_22;
  assign n_377 = ~(n_54 | n_39);
  assign n_441 = n_164 ^ n_353;
  assign n_442 = n_164 & n_177;
  assign n_443 = n_441 & n_190;
  assign n_445 = n_442 | n_443;
  assign n_447 = n_178 & n_177;
  assign n_448 = n_353 ^ n_191;
  assign n_714 = n_448 & n_445;
  assign n_715 = n_448 ^ n_445;
  assign n_716 = n_377 & n_447;
  assign n_717 = n_193 ^ n_447;
  assign n_872 = n_715 & n_66;
  assign n_875 = n_47 & n_714;
  assign n_876 = n_717 ^ n_714;
  assign n_915 = n_876 ^ n_872;
  assign n_916 = n_876 & n_872;
  assign n_917 = n_716 ^ n_875;
  assign n_1074 = ~n_377;
  assign n_1378 = ~n_89;
  assign n_1421 = n_916 | n_54;
  assign n_1430 = n_1421 | n_1074;
  assign n_1435 = n_1430;
  assign n_1438 = n_1435 | n_34;
  assign n_1520 = n_89;
  assign n_1521 = n_915 & n_1378;
  assign n_1522 = n_917 ^ n_1438;
  assign O[0] = n_13;
  assign O[1] = n_18;
  assign O[2] = n_23;
  assign O[3] = n_0;
  assign O[4] = n_117;
  assign O[5] = n_1074;
  assign O[6] = n_7;
  assign O[7] = n_4;
  assign O[8] = n_377;
  assign O[9] = n_18;
  assign O[10] = n_47;
  assign O[11] = n_12;
  assign O[12] = n_17;
  assign O[13] = n_18;
  assign O[14] = n_39;
  assign O[15] = n_8;
  assign O[16] = n_9;
  assign O[17] = n_238;
  assign O[18] = n_19;
  assign O[19] = n_1520;
  assign O[20] = n_377;
  assign O[21] = n_1520;
  assign O[22] = n_1521;
  assign O[23] = n_1522;
endmodule