// Library = EvoApprox 12x12
// Circuit = mul12x12_259
// Area   (45) = 25
// Delay  (45) = 0.240
// Power  (45) = 0.01
// MAE = 1191562.90000
// MSE = 2016791313588.19995
// MRE = 1023.99 %
// WCE = 3288326
// WCRE = 213211200 %
// EP = 100.0 %
module mul12x12_259(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_45, n_44, n_47, n_46, n_41, n_40, n_43, n_42, n_1118, n_2014;
  wire n_2015, n_770, n_30, n_31, n_32, n_33, n_34, n_35, n_36, n_37;
  wire n_38, n_39, n_2009, n_2008, n_2036, n_2003, n_2002, n_1450, n_1456, n_23;
  wire n_22, n_21, n_20, n_27, n_26, n_25, n_24, n_29, n_28, n_15;
  wire n_808, n_832, n_224, n_838, n_2021, n_2020, n_18, n_19, n_16, n_17;
  wire n_14, n_225, n_12, n_13, n_10, n_11, n_96, n_97, n_1124, n_86;
  wire n_1648, n_1998, n_1999, n_1660, n_1666, n_1667, n_112, n_113, n_76, n_77;
  wire n_70, n_71, n_809, n_2030, n_1672, n_1462, n_1463, n_8, n_9, n_4;
  wire n_5, n_6, n_7, n_0, n_1, n_2, n_3, n_58, n_59;
  assign n_0 = A[0];
  assign n_1 = A[0];
  assign n_2 = A[1];
  assign n_3 = A[1];
  assign n_4 = A[2];
  assign n_5 = A[2];
  assign n_6 = A[3];
  assign n_7 = A[3];
  assign n_8 = A[4];
  assign n_9 = A[4];
  assign n_10 = A[5];
  assign n_11 = A[5];
  assign n_12 = A[6];
  assign n_13 = A[6];
  assign n_14 = A[7];
  assign n_15 = A[7];
  assign n_16 = A[8];
  assign n_17 = A[8];
  assign n_18 = A[9];
  assign n_19 = A[9];
  assign n_20 = A[10];
  assign n_21 = A[10];
  assign n_22 = A[11];
  assign n_23 = A[11];
  assign n_24 = B[0];
  assign n_25 = B[0];
  assign n_26 = B[1];
  assign n_27 = B[1];
  assign n_28 = B[2];
  assign n_29 = B[2];
  assign n_30 = B[3];
  assign n_31 = B[3];
  assign n_32 = B[4];
  assign n_33 = B[4];
  assign n_34 = B[5];
  assign n_35 = B[5];
  assign n_36 = B[6];
  assign n_37 = B[6];
  assign n_38 = B[7];
  assign n_39 = B[7];
  assign n_40 = B[8];
  assign n_41 = B[8];
  assign n_42 = B[9];
  assign n_43 = B[9];
  assign n_44 = B[10];
  assign n_45 = B[10];
  assign n_46 = B[11];
  assign n_47 = B[11];
  assign n_58 = ~(n_26 | n_36 | n_40);
  assign n_59 = n_58;
  assign n_70 = n_59 & n_36;
  assign n_71 = n_70;
  assign n_76 = ~n_70;
  assign n_77 = n_76;
  assign n_86 = ~n_71;
  assign n_96 = ~(n_86 | n_70);
  assign n_97 = n_96;
  assign n_112 = ~n_97;
  assign n_113 = n_112;
  assign n_224 = ~n_97;
  assign n_225 = n_224;
  assign n_770 = n_22 & n_44;
  assign n_808 = ~n_225;
  assign n_809 = n_808;
  assign n_832 = n_20 & n_46;
  assign n_838 = n_22 & n_46;
  assign n_1118 = n_770 & n_832;
  assign n_1124 = n_770 | n_832;
  assign n_1450 = n_1124;
  assign n_1456 = n_113 & n_1118;
  HAX1 tmp81(.YS(n_1462), .YC(n_1463), .A(n_838), .B(n_1118));
  assign n_1648 = ~n_225;
  assign n_1660 = n_1450;
  assign n_1666 = ~n_77;
  assign n_1667 = n_1666;
  assign n_1672 = n_1462;
  assign n_1998 = n_225;
  assign n_1999 = n_1998;
  FAX1 tmp89(.YS(n_2002), .YC(n_2003), .A(n_1660), .B(n_1648), .C(n_1998));
  FAX1 tmp90(.YS(n_2008), .YC(n_2009), .A(n_1672), .B(n_70), .C(n_2003));
  FAX1 tmp91(.YS(n_2014), .YC(n_2015), .A(n_1456), .B(n_1666), .C(n_2009));
  assign n_2020 = n_809;
  assign n_2021 = n_2020;
  assign n_2030 = n_1999 & n_2008;
  assign n_2036 = n_809 | n_2014;
  assign O[0] = n_225;
  assign O[1] = n_44;
  assign O[2] = n_6;
  assign O[3] = n_32;
  assign O[4] = n_77;
  assign O[5] = n_20;
  assign O[6] = n_14;
  assign O[7] = n_24;
  assign O[8] = n_2;
  assign O[9] = n_44;
  assign O[10] = n_1667;
  assign O[11] = n_224;
  assign O[12] = n_10;
  assign O[13] = n_4;
  assign O[14] = n_71;
  assign O[15] = n_76;
  assign O[16] = n_18;
  assign O[17] = n_70;
  assign O[18] = n_38;
  assign O[19] = n_16;
  assign O[20] = n_2021;
  assign O[21] = n_2002;
  assign O[22] = n_2030;
  assign O[23] = n_2036;
endmodule