// Library = EvoApprox 12x12
// Circuit = mul12x12_262
// Area   (45) = 44
// Delay  (45) = 0.250
// Power  (45) = 0.01
// MAE = 845529.90000
// MSE = 1053528138498.80005
// MRE = 514.97 %
// WCE = 3295518
// WCRE = 108339500 %
// EP = 100.0 %
module mul12x12_262(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_239, n_253, n_257, n_1498, n_1420, n_1309, n_23, n_22, n_21, n_20;
  wire n_25, n_24, n_1182, n_1494, n_1512, n_1313, n_1283, n_1289, n_1500, n_1504;
  wire n_1506, n_1522, n_1520, n_1412, n_1408, n_8, n_9, n_4, n_5, n_6;
  wire n_7, n_0, n_1, n_2, n_3, n_1406, n_18, n_19, n_16, n_17;
  wire n_14, n_15, n_12, n_13, n_10, n_11, n_50, n_47, n_1311, n_1416;
  wire n_1510, n_1414, n_1516, n_667, n_1514, n_1410, n_1518, n_1180, n_1418;
  assign n_0 = A[0];
  assign n_1 = A[1];
  assign n_2 = A[2];
  assign n_3 = A[3];
  assign n_4 = A[4];
  assign n_5 = A[5];
  assign n_6 = A[6];
  assign n_7 = A[7];
  assign n_8 = A[8];
  assign n_9 = A[9];
  assign n_10 = A[10];
  assign n_11 = A[11];
  assign n_12 = B[0];
  assign n_13 = B[1];
  assign n_14 = B[2];
  assign n_15 = B[3];
  assign n_16 = B[4];
  assign n_17 = B[5];
  assign n_18 = B[6];
  assign n_19 = B[7];
  assign n_20 = B[8];
  assign n_21 = B[9];
  assign n_22 = B[10];
  assign n_23 = B[11];
  assign n_24 = ~(n_2 ^ n_2);
  assign n_25 = ~(n_14 | n_24);
  assign n_47 = n_9 & n_25;
  assign n_50 = ~n_25;
  assign n_239 = ~n_50;
  assign n_253 = ~(n_239 | n_47);
  assign n_257 = ~(n_50 | n_23);
  assign n_667 = n_253;
  assign n_1180 = n_10 & n_22;
  assign n_1182 = n_11 & n_22;
  assign n_1283 = n_1182 & n_1180;
  assign n_1289 = n_1283 | n_47;
  assign n_1309 = n_9 & n_23;
  assign n_1311 = n_10 & n_23;
  assign n_1313 = n_11 & n_23;
  assign n_1406 = ~n_667;
  assign n_1408 = n_257;
  assign n_1410 = n_1309 | n_1406;
  assign n_1412 = n_1182 ^ n_1311;
  assign n_1414 = ~n_667;
  assign n_1416 = n_1289 & n_22;
  assign n_1418 = n_1412 ^ n_1289;
  assign n_1420 = n_1414 | n_1416;
  assign n_1494 = ~n_1408;
  assign n_1498 = ~n_1494;
  assign n_1500 = n_253;
  assign n_1504 = n_1418 ^ n_1410;
  assign n_1506 = n_1418 & n_1410;
  assign n_1510 = n_1504 ^ n_1498;
  assign n_1512 = n_1506;
  assign n_1514 = n_1313 ^ n_1420;
  assign n_1516 = n_1313 & n_1420;
  assign n_1518 = n_1514 & n_1512;
  assign n_1520 = n_1514 ^ n_1512;
  assign n_1522 = n_1516 | n_1518;
  assign O[0] = n_257;
  assign O[1] = n_22;
  assign O[2] = n_667;
  assign O[3] = n_16;
  assign O[4] = n_25;
  assign O[5] = n_6;
  assign O[6] = n_11;
  assign O[7] = n_20;
  assign O[8] = n_9;
  assign O[9] = n_10;
  assign O[10] = n_23;
  assign O[11] = n_24;
  assign O[12] = n_13;
  assign O[13] = n_22;
  assign O[14] = n_11;
  assign O[15] = n_12;
  assign O[16] = n_5;
  assign O[17] = n_2;
  assign O[18] = n_11;
  assign O[19] = n_1408;
  assign O[20] = n_1500;
  assign O[21] = n_1510;
  assign O[22] = n_1520;
  assign O[23] = n_1522;
endmodule