// Library = EvoApprox 12x12
// Circuit = mul12x12_263
// Area   (45) = 46
// Delay  (45) = 0.280
// Power  (45) = 0.01
// MAE = 990019.80000
// MSE = 1562148457133.00000
// MRE = 168.59 %
// WCE = 3295628
// WCRE = 4918300 %
// EP = 100.0 %
module mul12x12_263(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_1714, n_36, n_42, n_37, n_57, n_23, n_22, n_21, n_20, n_27;
  wire n_26, n_25, n_24, n_1953, n_29, n_28, n_1961, n_1960, n_1880, n_61;
  wire n_60, n_1874, n_39, n_38, n_2032, n_8, n_9, n_159, n_4, n_5;
  wire n_6, n_7, n_0, n_1, n_2, n_3, n_30, n_31, n_32, n_33;
  wire n_34, n_35, n_18, n_19, n_16, n_17, n_14, n_15, n_12, n_13;
  wire n_10, n_11, n_158, n_45, n_2041, n_2040, n_44, n_43, n_56, n_47;
  wire n_54, n_1866, n_46, n_1952, n_1794, n_41, n_2033, n_40;
  assign n_0 = A[0];
  assign n_1 = A[0];
  assign n_2 = A[1];
  assign n_3 = A[1];
  assign n_4 = A[2];
  assign n_5 = A[2];
  assign n_6 = A[3];
  assign n_7 = A[3];
  assign n_8 = A[4];
  assign n_9 = A[4];
  assign n_10 = A[5];
  assign n_11 = A[5];
  assign n_12 = A[6];
  assign n_13 = A[6];
  assign n_14 = A[7];
  assign n_15 = A[7];
  assign n_16 = A[8];
  assign n_17 = A[8];
  assign n_18 = A[9];
  assign n_19 = A[9];
  assign n_20 = A[10];
  assign n_21 = A[10];
  assign n_22 = A[11];
  assign n_23 = A[11];
  assign n_24 = B[0];
  assign n_25 = B[0];
  assign n_26 = B[1];
  assign n_27 = B[1];
  assign n_28 = B[2];
  assign n_29 = B[2];
  assign n_30 = B[3];
  assign n_31 = B[3];
  assign n_32 = B[4];
  assign n_33 = B[4];
  assign n_34 = B[5];
  assign n_35 = B[5];
  assign n_36 = B[6];
  assign n_37 = B[6];
  assign n_38 = B[7];
  assign n_39 = B[7];
  assign n_40 = B[8];
  assign n_41 = B[8];
  assign n_42 = B[9];
  assign n_43 = B[9];
  assign n_44 = B[10];
  assign n_45 = B[10];
  assign n_46 = B[11];
  assign n_47 = B[11];
  assign n_54 = ~(n_34 & n_0 & n_32);
  assign n_56 = ~(n_34 | n_54);
  assign n_57 = n_56;
  assign n_60 = n_57;
  assign n_61 = n_60;
  assign n_158 = ~n_61;
  assign n_159 = n_158;
  assign n_1714 = n_22 & n_44;
  assign n_1794 = n_159 & n_44;
  assign n_1866 = n_18 & n_46;
  assign n_1874 = n_20 & n_46;
  assign n_1880 = n_22 & n_46;
  assign n_1952 = n_1794 & n_1866;
  assign n_1953 = n_1952;
  FAX1 tmp73(.YS(n_1960), .YC(n_1961), .A(n_1714), .B(n_1874), .C(n_22));
  HAX1 tmp74(.YS(n_2032), .YC(n_2033), .A(n_1960), .B(n_1953));
  FAX1 tmp75(.YS(n_2040), .YC(n_2041), .A(n_1880), .B(n_1961), .C(n_2033));
  assign O[0] = n_57;
  assign O[1] = n_44;
  assign O[2] = n_22;
  assign O[3] = n_16;
  assign O[4] = n_26;
  assign O[5] = n_20;
  assign O[6] = n_159;
  assign O[7] = n_8;
  assign O[8] = n_34;
  assign O[9] = n_28;
  assign O[10] = n_38;
  assign O[11] = n_0;
  assign O[12] = n_42;
  assign O[13] = n_4;
  assign O[14] = n_14;
  assign O[15] = n_24;
  assign O[16] = n_2;
  assign O[17] = n_12;
  assign O[18] = n_38;
  assign O[19] = n_16;
  assign O[20] = n_61;
  assign O[21] = n_2032;
  assign O[22] = n_2040;
  assign O[23] = n_2041;
endmodule