// Library = EvoApprox 12x12
// Circuit = mul12x12_232
// Area   (45) = 111
// Delay  (45) = 0.580
// Power  (45) = 0.05
// MAE = 440636.30000
// MSE = 292317268132.00000
// MRE = 147.34 %
// WCE = 1625474
// WCRE = 5568100 %
// EP = 100.0 %
module mul12x12_232(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_540, n_1947, n_541, n_1946, n_45, n_1953, n_47, n_46, n_41, n_40;
  wire n_43, n_42, n_2018, n_2019, n_1706, n_1626, n_1627, n_30, n_31, n_32;
  wire n_33, n_34, n_35, n_36, n_37, n_38, n_39, n_1952, n_44, n_1866;
  wire n_23, n_22, n_21, n_20, n_27, n_26, n_25, n_24, n_29, n_28;
  wire n_1874, n_2027, n_2026, n_18, n_19, n_16, n_17, n_1961, n_1960, n_12;
  wire n_13, n_10, n_11, n_1714, n_584, n_14, n_15, n_89, n_88, n_1858;
  wire n_1548, n_2041, n_2040, n_1794, n_1795, n_2032, n_2033, n_1778, n_1779, n_63;
  wire n_62, n_1381, n_1380, n_208, n_209, n_1787, n_1786, n_8, n_9, n_4;
  wire n_5, n_6, n_7, n_0, n_1, n_2, n_3, n_1880, n_58, n_59;
  wire n_52, n_53;
  assign n_0 = A[0];
  assign n_1 = A[0];
  assign n_2 = A[1];
  assign n_3 = A[1];
  assign n_4 = A[2];
  assign n_5 = A[2];
  assign n_6 = A[3];
  assign n_7 = A[3];
  assign n_8 = A[4];
  assign n_9 = A[4];
  assign n_10 = A[5];
  assign n_11 = A[5];
  assign n_12 = A[6];
  assign n_13 = A[6];
  assign n_14 = A[7];
  assign n_15 = A[7];
  assign n_16 = A[8];
  assign n_17 = A[8];
  assign n_18 = A[9];
  assign n_19 = A[9];
  assign n_20 = A[10];
  assign n_21 = A[10];
  assign n_22 = A[11];
  assign n_23 = A[11];
  assign n_24 = B[0];
  assign n_25 = B[0];
  assign n_26 = B[1];
  assign n_27 = B[1];
  assign n_28 = B[2];
  assign n_29 = B[2];
  assign n_30 = B[3];
  assign n_31 = B[3];
  assign n_32 = B[4];
  assign n_33 = B[4];
  assign n_34 = B[5];
  assign n_35 = B[5];
  assign n_36 = B[6];
  assign n_37 = B[6];
  assign n_38 = B[7];
  assign n_39 = B[7];
  assign n_40 = B[8];
  assign n_41 = B[8];
  assign n_42 = B[9];
  assign n_43 = B[9];
  assign n_44 = B[10];
  assign n_45 = B[10];
  assign n_46 = B[11];
  assign n_47 = B[11];
  assign n_52 = ~(n_44 ^ n_44);
  assign n_53 = n_52;
  assign n_58 = ~n_53;
  assign n_59 = n_58;
  assign n_62 = n_53;
  assign n_63 = n_62;
  assign n_88 = ~n_62;
  assign n_89 = n_88;
  assign n_208 = ~n_89;
  assign n_209 = n_208;
  assign n_540 = ~n_209;
  assign n_541 = n_540;
  assign n_584 = n_18;
  assign n_1380 = n_22 & n_40;
  assign n_1381 = n_1380;
  assign n_1548 = n_22 & n_42;
  HAX1 tmp75(.YS(n_1626), .YC(n_1627), .A(n_1381), .B(n_20));
  assign n_1706 = n_20 & n_44;
  assign n_1714 = n_22 & n_44;
  assign n_1778 = n_63 & n_44;
  assign n_1779 = n_1778;
  HAX1 tmp80(.YS(n_1786), .YC(n_1787), .A(n_1626), .B(n_40));
  FAX1 tmp81(.YS(n_1794), .YC(n_1795), .A(n_1548), .B(n_1706), .C(n_1627));
  assign n_1858 = n_16 & n_46;
  assign n_1866 = n_18 & n_46;
  assign n_1874 = n_20 & n_46;
  assign n_1880 = n_22 & n_46;
  FAX1 tmp86(.YS(n_1946), .YC(n_1947), .A(n_1786), .B(n_1858), .C(n_1779));
  FAX1 tmp87(.YS(n_1952), .YC(n_1953), .A(n_1794), .B(n_1866), .C(n_1787));
  FAX1 tmp88(.YS(n_1960), .YC(n_1961), .A(n_1714), .B(n_1874), .C(n_1795));
  HAX1 tmp89(.YS(n_2018), .YC(n_2019), .A(n_1946), .B(n_584));
  FAX1 tmp90(.YS(n_2026), .YC(n_2027), .A(n_1952), .B(n_1947), .C(n_2019));
  FAX1 tmp91(.YS(n_2032), .YC(n_2033), .A(n_1960), .B(n_1953), .C(n_2027));
  FAX1 tmp92(.YS(n_2040), .YC(n_2041), .A(n_1880), .B(n_1961), .C(n_2033));
  assign O[0] = n_18;
  assign O[1] = n_62;
  assign O[2] = n_59;
  assign O[3] = n_32;
  assign O[4] = n_541;
  assign O[5] = n_4;
  assign O[6] = n_30;
  assign O[7] = n_24;
  assign O[8] = n_209;
  assign O[9] = n_28;
  assign O[10] = n_38;
  assign O[11] = n_208;
  assign O[12] = n_53;
  assign O[13] = n_36;
  assign O[14] = n_63;
  assign O[15] = n_24;
  assign O[16] = n_34;
  assign O[17] = n_14;
  assign O[18] = n_22;
  assign O[19] = n_2018;
  assign O[20] = n_2026;
  assign O[21] = n_2032;
  assign O[22] = n_2040;
  assign O[23] = n_2041;
endmodule