// Library = EvoApprox 12x12
// Circuit = mul12x12_245
// Area   (45) = 65
// Delay  (45) = 0.400
// Power  (45) = 0.02
// MAE = 525141.70000
// MSE = 422122945853.79999
// MRE = 95.23 %
// WCE = 2220971
// WCRE = 204703 %
// EP = 100.0 %
module mul12x12_245(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_45, n_44, n_47, n_46, n_41, n_40, n_1756, n_42, n_49, n_48;
  wire n_1594, n_149, n_148, n_2014, n_2015, n_1446, n_30, n_31, n_32, n_33;
  wire n_34, n_35, n_36, n_37, n_38, n_39, n_1742, n_1750, n_1290, n_2007;
  wire n_2006, n_1438, n_2034, n_22, n_21, n_20, n_27, n_26, n_25, n_24;
  wire n_29, n_28, n_2026, n_18, n_19, n_16, n_17, n_14, n_15, n_12;
  wire n_13, n_10, n_11, n_1521, n_1520, n_105, n_104, n_23, n_2040, n_43;
  wire n_72, n_73, n_1987, n_1986, n_1981, n_1980, n_1824, n_1825, n_1677, n_1676;
  wire n_65, n_64, n_1831, n_1830, n_8, n_9, n_4, n_5, n_6, n_7;
  wire n_0, n_1, n_2, n_3, n_1602, n_1603, n_602;
  assign n_0 = A[0];
  assign n_1 = A[0];
  assign n_2 = A[1];
  assign n_3 = A[1];
  assign n_4 = A[2];
  assign n_5 = A[2];
  assign n_6 = A[3];
  assign n_7 = A[3];
  assign n_8 = A[4];
  assign n_9 = A[4];
  assign n_10 = A[5];
  assign n_11 = A[5];
  assign n_12 = A[6];
  assign n_13 = A[6];
  assign n_14 = A[7];
  assign n_15 = A[7];
  assign n_16 = A[8];
  assign n_17 = A[8];
  assign n_18 = A[9];
  assign n_19 = A[9];
  assign n_20 = A[10];
  assign n_21 = A[10];
  assign n_22 = A[11];
  assign n_23 = A[11];
  assign n_24 = B[0];
  assign n_25 = B[0];
  assign n_26 = B[1];
  assign n_27 = B[1];
  assign n_28 = B[2];
  assign n_29 = B[2];
  assign n_30 = B[3];
  assign n_31 = B[3];
  assign n_32 = B[4];
  assign n_33 = B[4];
  assign n_34 = B[5];
  assign n_35 = B[5];
  assign n_36 = B[6];
  assign n_37 = B[6];
  assign n_38 = B[7];
  assign n_39 = B[7];
  assign n_40 = B[8];
  assign n_41 = B[8];
  assign n_42 = B[9];
  assign n_43 = B[9];
  assign n_44 = B[10];
  assign n_45 = B[10];
  assign n_46 = B[11];
  assign n_47 = B[11];
  assign n_48 = ~(n_12 & n_46 & n_22);
  assign n_49 = n_48;
  assign n_64 = ~(n_49 | n_12);
  assign n_65 = n_64;
  assign n_72 = n_65;
  assign n_73 = n_72;
  assign n_104 = ~n_65;
  assign n_105 = n_104;
  assign n_148 = ~n_105;
  assign n_149 = n_148;
  assign n_602 = ~n_105;
  assign n_1290 = n_22 & n_40;
  assign n_1438 = n_20 & n_42;
  assign n_1446 = n_22 & n_42;
  assign n_1520 = n_1290 & n_1438;
  assign n_1521 = n_1520;
  assign n_1594 = n_20 & n_44;
  assign n_1602 = n_22 & n_44;
  assign n_1603 = n_1602;
  FAX1 tmp78(.YS(n_1676), .YC(n_1677), .A(n_1446), .B(n_1594), .C(n_1521));
  assign n_1742 = n_18 & n_46;
  assign n_1750 = n_20 & n_46;
  assign n_1756 = n_22 & n_46;
  HAX1 tmp82(.YS(n_1824), .YC(n_1825), .A(n_1676), .B(n_1742));
  FAX1 tmp83(.YS(n_1830), .YC(n_1831), .A(n_1603), .B(n_1750), .C(n_1677));
  assign n_1980 = ~n_65;
  assign n_1981 = n_1980;
  assign n_1986 = n_1824 | n_1676;
  assign n_1987 = n_1986;
  FAX1 tmp88(.YS(n_2006), .YC(n_2007), .A(n_1830), .B(n_1825), .C(n_1987));
  FAX1 tmp89(.YS(n_2014), .YC(n_2015), .A(n_1756), .B(n_1831), .C(n_2007));
  assign n_2026 = n_73 | n_2006;
  assign n_2034 = n_1980 & n_2014;
  assign n_2040 = n_1981 & n_2015;
  assign O[0] = n_73;
  assign O[1] = n_12;
  assign O[2] = n_38;
  assign O[3] = n_64;
  assign O[4] = n_42;
  assign O[5] = n_602;
  assign O[6] = n_30;
  assign O[7] = n_40;
  assign O[8] = n_2;
  assign O[9] = n_28;
  assign O[10] = n_22;
  assign O[11] = n_32;
  assign O[12] = n_42;
  assign O[13] = n_4;
  assign O[14] = n_46;
  assign O[15] = n_8;
  assign O[16] = n_34;
  assign O[17] = n_12;
  assign O[18] = n_38;
  assign O[19] = n_16;
  assign O[20] = n_149;
  assign O[21] = n_2026;
  assign O[22] = n_2034;
  assign O[23] = n_2040;
endmodule