// Library = EvoApprox 12x12
// Circuit = mul12x12_253
// Area   (45) = 40
// Delay  (45) = 0.330
// Power  (45) = 0.01
// MAE = 890573.80000
// MSE = 1090038660945.90002
// MRE = 560.92 %
// WCE = 2671648
// WCRE = 108185500 %
// EP = 100.0 %
module mul12x12_253(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_875, n_190, n_191, n_193, n_23, n_22, n_21, n_20, n_27, n_915;
  wire n_917, n_85, n_164, n_716, n_88, n_65, n_442, n_445, n_912, n_717;
  wire n_1522, n_1521, n_1520, n_714, n_448, n_715, n_8, n_9, n_4, n_5;
  wire n_6, n_7, n_0, n_1, n_2, n_3, n_873, n_876, n_18, n_19;
  wire n_16, n_17, n_14, n_15, n_12, n_13, n_10, n_11, n_177, n_50;
  wire n_447, n_168, n_561, n_178;
  assign n_0 = A[0];
  assign n_1 = A[1];
  assign n_2 = A[2];
  assign n_3 = A[3];
  assign n_4 = A[4];
  assign n_5 = A[5];
  assign n_6 = A[6];
  assign n_7 = A[7];
  assign n_8 = A[8];
  assign n_9 = A[9];
  assign n_10 = A[10];
  assign n_11 = A[11];
  assign n_12 = B[0];
  assign n_13 = B[1];
  assign n_14 = B[2];
  assign n_15 = B[3];
  assign n_16 = B[4];
  assign n_17 = B[5];
  assign n_18 = B[6];
  assign n_19 = B[7];
  assign n_20 = B[8];
  assign n_21 = B[9];
  assign n_22 = B[10];
  assign n_23 = B[11];
  assign n_27 = n_12 ^ n_12;
  assign n_50 = ~n_27;
  assign n_65 = ~(n_16 | n_50);
  assign n_85 = ~(n_50 | n_27);
  assign n_88 = n_65;
  assign n_164 = n_11 & n_21;
  assign n_168 = n_85;
  assign n_177 = n_10 & n_22;
  assign n_178 = n_11 & n_22;
  assign n_190 = n_9 & n_23;
  assign n_191 = n_10 & n_23;
  assign n_193 = n_11 & n_23;
  assign n_442 = n_164 & n_177;
  assign n_445 = n_442 | n_190;
  assign n_447 = n_178 & n_191;
  assign n_448 = n_178 | n_191;
  assign n_561 = ~(n_88 | n_85);
  assign n_714 = n_448 & n_445;
  assign n_715 = n_448 ^ n_445;
  assign n_716 = n_22 & n_447;
  assign n_717 = n_193 ^ n_447;
  assign n_873 = n_715 ^ n_88;
  assign n_875 = n_717 & n_714;
  assign n_876 = ~(n_717 ^ n_714);
  assign n_912 = n_873;
  assign n_915 = n_876;
  assign n_917 = n_716 ^ n_875;
  assign n_1520 = n_912;
  assign n_1521 = ~(n_915 | n_27);
  assign n_1522 = n_917 ^ n_88;
  assign O[0] = n_65;
  assign O[1] = n_18;
  assign O[2] = n_27;
  assign O[3] = n_16;
  assign O[4] = n_17;
  assign O[5] = n_10;
  assign O[6] = n_15;
  assign O[7] = n_168;
  assign O[8] = n_17;
  assign O[9] = n_50;
  assign O[10] = n_3;
  assign O[11] = n_168;
  assign O[12] = n_9;
  assign O[13] = n_18;
  assign O[14] = n_23;
  assign O[15] = n_12;
  assign O[16] = n_17;
  assign O[17] = n_6;
  assign O[18] = n_19;
  assign O[19] = n_8;
  assign O[20] = n_561;
  assign O[21] = n_1520;
  assign O[22] = n_1521;
  assign O[23] = n_1522;
endmodule