// Library = EvoApprox 12x12
// Circuit = mul12x12_261
// Area   (45) = 54
// Delay  (45) = 0.340
// Power  (45) = 0.02
// MAE = 885278.70000
// MSE = 1220524749385.89990
// MRE = 334.38 %
// WCE = 3293639
// WCRE = 65555200 %
// EP = 100.0 %
module mul12x12_261(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_1748, n_45, n_44, n_47, n_46, n_41, n_40, n_43, n_42, n_49;
  wire n_48, n_240, n_241, n_30, n_31, n_32, n_33, n_34, n_35, n_36;
  wire n_37, n_38, n_39, n_1744, n_392, n_390, n_394, n_662, n_664, n_665;
  wire n_668, n_669, n_23, n_22, n_21, n_20, n_27, n_26, n_25, n_24;
  wire n_802, n_29, n_28, n_804, n_805, n_18, n_19, n_16, n_17, n_14;
  wire n_15, n_12, n_13, n_10, n_11, n_521, n_520, n_336, n_337, n_1714;
  wire n_364, n_2044, n_2040, n_2042, n_508, n_800, n_801, n_63, n_62, n_518;
  wire n_756, n_1734, n_758, n_516, n_517, n_8, n_9, n_4, n_5, n_6;
  wire n_7, n_0, n_1, n_2, n_3, n_50, n_51, n_54, n_55, n_761;
  wire n_760;
  assign n_0 = A[0];
  assign n_1 = A[0];
  assign n_2 = A[1];
  assign n_3 = A[1];
  assign n_4 = A[2];
  assign n_5 = A[2];
  assign n_6 = A[3];
  assign n_7 = A[3];
  assign n_8 = A[4];
  assign n_9 = A[4];
  assign n_10 = A[5];
  assign n_11 = A[5];
  assign n_12 = A[6];
  assign n_13 = A[6];
  assign n_14 = A[7];
  assign n_15 = A[7];
  assign n_16 = A[8];
  assign n_17 = A[8];
  assign n_18 = A[9];
  assign n_19 = A[9];
  assign n_20 = A[10];
  assign n_21 = A[10];
  assign n_22 = A[11];
  assign n_23 = A[11];
  assign n_24 = B[0];
  assign n_25 = B[0];
  assign n_26 = B[1];
  assign n_27 = B[1];
  assign n_28 = B[2];
  assign n_29 = B[2];
  assign n_30 = B[3];
  assign n_31 = B[3];
  assign n_32 = B[4];
  assign n_33 = B[4];
  assign n_34 = B[5];
  assign n_35 = B[5];
  assign n_36 = B[6];
  assign n_37 = B[6];
  assign n_38 = B[7];
  assign n_39 = B[7];
  assign n_40 = B[8];
  assign n_41 = B[8];
  assign n_42 = B[9];
  assign n_43 = B[9];
  assign n_44 = B[10];
  assign n_45 = B[10];
  assign n_46 = B[11];
  assign n_47 = B[11];
  assign n_48 = ~(n_12 ^ n_12);
  assign n_49 = n_48;
  assign n_50 = ~n_49;
  assign n_51 = n_50;
  assign n_54 = ~n_49;
  assign n_55 = n_54;
  assign n_62 = ~n_55;
  assign n_63 = n_62;
  assign n_240 = ~(n_18 | n_62);
  assign n_241 = n_240;
  assign n_336 = n_22 & n_42;
  assign n_337 = n_336;
  assign n_364 = n_22 & n_44;
  assign n_390 = n_18 & n_44;
  assign n_392 = n_20 & n_46;
  assign n_394 = n_22 & n_46;
  assign n_508 = ~n_241;
  assign n_516 = n_337 | n_394;
  assign n_517 = n_516;
  assign n_518 = n_364 & n_392;
  HAX1 tmp79(.YS(n_520), .YC(n_521), .A(n_364), .B(n_392));
  assign n_662 = n_520 & n_517;
  HAX1 tmp81(.YS(n_664), .YC(n_665), .A(n_520), .B(n_517));
  HAX1 tmp82(.YS(n_668), .YC(n_669), .A(n_394), .B(n_518));
  assign n_756 = n_664;
  assign n_758 = n_46 & n_662;
  HAX1 tmp85(.YS(n_760), .YC(n_761), .A(n_668), .B(n_662));
  HAX1 tmp86(.YS(n_800), .YC(n_801), .A(n_756), .B(n_390));
  assign n_802 = n_760;
  HAX1 tmp88(.YS(n_804), .YC(n_805), .A(n_669), .B(n_758));
  assign n_1714 = n_801;
  assign n_1734 = n_1714;
  assign n_1744 = n_1734;
  assign n_1748 = n_1744;
  assign n_2040 = n_800;
  assign n_2042 = n_802 | n_1748;
  assign n_2044 = n_804;
  assign O[0] = n_49;
  assign O[1] = n_44;
  assign O[2] = n_22;
  assign O[3] = n_16;
  assign O[4] = n_26;
  assign O[5] = n_50;
  assign O[6] = n_63;
  assign O[7] = n_508;
  assign O[8] = n_18;
  assign O[9] = n_54;
  assign O[10] = n_51;
  assign O[11] = n_32;
  assign O[12] = n_42;
  assign O[13] = n_20;
  assign O[14] = n_46;
  assign O[15] = n_8;
  assign O[16] = n_34;
  assign O[17] = n_62;
  assign O[18] = n_38;
  assign O[19] = n_48;
  assign O[20] = n_805;
  assign O[21] = n_2040;
  assign O[22] = n_2042;
  assign O[23] = n_2044;
endmodule