// Library = EvoApprox 12x12
// Circuit = mul12x12_264
// Area   (45) = 40
// Delay  (45) = 0.360
// Power  (45) = 0.02
// MAE = 923841.30000
// MSE = 1338953490119.60010
// MRE = 244.10 %
// WCE = 3301889
// WCRE = 15782400 %
// EP = 100.0 %
module mul12x12_264(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_1602, n_36, n_42, n_1831, n_37, n_2020, n_71, n_23, n_22, n_21;
  wire n_20, n_27, n_26, n_25, n_24, n_1677, n_1676, n_29, n_28, n_1594;
  wire n_1595, n_1756, n_2034, n_2040, n_2014, n_2015, n_214, n_129, n_128, n_39;
  wire n_38, n_1830, n_1446, n_189, n_188, n_8, n_9, n_97, n_4, n_5;
  wire n_6, n_7, n_0, n_1, n_2, n_3, n_30, n_31, n_32, n_33;
  wire n_34, n_35, n_18, n_19, n_16, n_17, n_14, n_15, n_12, n_13;
  wire n_10, n_11, n_96, n_45, n_58, n_59, n_2026, n_1588, n_44, n_74;
  wire n_75, n_43, n_70, n_47, n_2007, n_2006, n_46, n_2021, n_41, n_1825;
  wire n_50, n_1824, n_40;
  assign n_0 = A[0];
  assign n_1 = A[0];
  assign n_2 = A[1];
  assign n_3 = A[1];
  assign n_4 = A[2];
  assign n_5 = A[2];
  assign n_6 = A[3];
  assign n_7 = A[3];
  assign n_8 = A[4];
  assign n_9 = A[4];
  assign n_10 = A[5];
  assign n_11 = A[5];
  assign n_12 = A[6];
  assign n_13 = A[6];
  assign n_14 = A[7];
  assign n_15 = A[7];
  assign n_16 = A[8];
  assign n_17 = A[8];
  assign n_18 = A[9];
  assign n_19 = A[9];
  assign n_20 = A[10];
  assign n_21 = A[10];
  assign n_22 = A[11];
  assign n_23 = A[11];
  assign n_24 = B[0];
  assign n_25 = B[0];
  assign n_26 = B[1];
  assign n_27 = B[1];
  assign n_28 = B[2];
  assign n_29 = B[2];
  assign n_30 = B[3];
  assign n_31 = B[3];
  assign n_32 = B[4];
  assign n_33 = B[4];
  assign n_34 = B[5];
  assign n_35 = B[5];
  assign n_36 = B[6];
  assign n_37 = B[6];
  assign n_38 = B[7];
  assign n_39 = B[7];
  assign n_40 = B[8];
  assign n_41 = B[8];
  assign n_42 = B[9];
  assign n_43 = B[9];
  assign n_44 = B[10];
  assign n_45 = B[10];
  assign n_46 = B[11];
  assign n_47 = B[11];
  assign n_50 = ~(n_28 | n_44 | n_34);
  assign n_58 = n_34 & n_50;
  assign n_59 = n_58;
  assign n_70 = ~n_59;
  assign n_71 = n_70;
  assign n_74 = n_71;
  assign n_75 = n_74;
  assign n_96 = ~(n_18 | n_28 | n_75);
  assign n_97 = n_96;
  assign n_128 = ~n_97;
  assign n_129 = n_128;
  assign n_188 = ~n_129;
  assign n_189 = n_188;
  assign n_214 = ~n_129;
  assign n_1446 = n_22 & n_42;
  assign n_1588 = n_18 & n_44;
  assign n_1594 = n_20 & n_1588;
  assign n_1595 = n_1594;
  assign n_1602 = n_22 & n_44;
  assign n_1676 = n_1446;
  assign n_1677 = n_1676;
  assign n_1756 = n_22 & n_46;
  FAX1 tmp81(.YS(n_1824), .YC(n_1825), .A(n_18), .B(n_214), .C(n_1595));
  FAX1 tmp82(.YS(n_1830), .YC(n_1831), .A(n_1602), .B(n_20), .C(n_1677));
  FAX1 tmp83(.YS(n_2006), .YC(n_2007), .A(n_1830), .B(n_1825), .C(n_46));
  FAX1 tmp84(.YS(n_2014), .YC(n_2015), .A(n_1756), .B(n_1831), .C(n_2007));
  assign n_2020 = ~n_129;
  assign n_2021 = n_2020;
  assign n_2026 = n_189 | n_2006;
  assign n_2034 = n_189 | n_2014;
  assign n_2040 = n_97 | n_2015;
  assign O[0] = n_129;
  assign O[1] = n_214;
  assign O[2] = n_59;
  assign O[3] = n_32;
  assign O[4] = n_189;
  assign O[5] = n_4;
  assign O[6] = n_14;
  assign O[7] = n_24;
  assign O[8] = n_97;
  assign O[9] = n_44;
  assign O[10] = n_6;
  assign O[11] = n_0;
  assign O[12] = n_26;
  assign O[13] = n_74;
  assign O[14] = n_71;
  assign O[15] = n_40;
  assign O[16] = n_97;
  assign O[17] = n_70;
  assign O[18] = n_38;
  assign O[19] = n_96;
  assign O[20] = n_2021;
  assign O[21] = n_2026;
  assign O[22] = n_2034;
  assign O[23] = n_2040;
endmodule