// Library = EvoApprox 12x12
// Circuit = mul12x12_267
// Area   (45) = 33
// Delay  (45) = 0.230
// Power  (45) = 0.01
// MAE = 1225469.00000
// MSE = 2066851461030.30005
// MRE = 995.96 %
// WCE = 3310466
// WCRE = 210329700 %
// EP = 100.0 %
module mul12x12_267(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_1274, n_234, n_23, n_22, n_21, n_20, n_1494, n_1377, n_1500, n_1387;
  wire n_1385, n_1383, n_1406, n_1185, n_1504, n_1508, n_1490, n_189, n_1408, n_1379;
  wire n_8, n_9, n_4, n_5, n_6, n_7, n_0, n_1, n_2, n_3;
  wire n_30, n_31, n_1275, n_18, n_19, n_16, n_17, n_14, n_15, n_12;
  wire n_13, n_10, n_11, n_1522, n_1520, n_54, n_1512, n_1510, n_1516, n_1514;
  wire n_1410, n_1518;
  assign n_0 = A[0];
  assign n_1 = A[1];
  assign n_2 = A[2];
  assign n_3 = A[3];
  assign n_4 = A[4];
  assign n_5 = A[5];
  assign n_6 = A[6];
  assign n_7 = A[7];
  assign n_8 = A[8];
  assign n_9 = A[9];
  assign n_10 = A[10];
  assign n_11 = A[11];
  assign n_12 = B[0];
  assign n_13 = B[1];
  assign n_14 = B[2];
  assign n_15 = B[3];
  assign n_16 = B[4];
  assign n_17 = B[5];
  assign n_18 = B[6];
  assign n_19 = B[7];
  assign n_20 = B[8];
  assign n_21 = B[9];
  assign n_22 = B[10];
  assign n_23 = B[11];
  assign n_30 = n_5 ^ n_5;
  assign n_31 = n_30;
  assign n_54 = ~n_31;
  assign n_189 = ~n_30;
  assign n_234 = ~n_31;
  assign n_1185 = ~(n_11 | n_54);
  assign n_1274 = ~(n_10 & n_22);
  assign n_1275 = n_11 & n_22;
  assign n_1377 = ~(n_1274 | n_23);
  assign n_1379 = n_30 ^ n_1275;
  assign n_1383 = n_1379 & n_10;
  assign n_1385 = n_1379 ^ n_1377;
  assign n_1387 = n_31 | n_1383;
  assign n_1406 = n_21 & n_23;
  assign n_1408 = n_10 & n_23;
  assign n_1410 = n_11 & n_23;
  assign n_1490 = ~n_189;
  assign n_1494 = ~(n_189 & n_1406);
  assign n_1500 = n_1494 ^ n_54;
  assign n_1504 = n_1385 | n_1408;
  assign n_1508 = n_1504 & n_234;
  assign n_1510 = ~n_1504;
  assign n_1512 = n_1185 | n_1508;
  assign n_1514 = n_1383 ^ n_1410;
  assign n_1516 = n_1387 & n_1410;
  assign n_1518 = n_1514 & n_1512;
  assign n_1520 = n_1514 ^ n_1512;
  assign n_1522 = n_1516 | n_1518;
  assign O[0] = n_1185;
  assign O[1] = n_54;
  assign O[2] = n_11;
  assign O[3] = n_4;
  assign O[4] = n_1;
  assign O[5] = n_18;
  assign O[6] = n_11;
  assign O[7] = n_4;
  assign O[8] = n_5;
  assign O[9] = n_2;
  assign O[10] = n_23;
  assign O[11] = n_12;
  assign O[12] = n_189;
  assign O[13] = n_6;
  assign O[14] = n_19;
  assign O[15] = n_20;
  assign O[16] = n_17;
  assign O[17] = n_30;
  assign O[18] = n_7;
  assign O[19] = n_1490;
  assign O[20] = n_1500;
  assign O[21] = n_1510;
  assign O[22] = n_1520;
  assign O[23] = n_1522;
endmodule