// Library = EvoApprox 12x12
// Circuit = mul12x12_269
// Area   (45) = 48
// Delay  (45) = 0.250
// Power  (45) = 0.01
// MAE = 883332.40000
// MSE = 1200124911412.00000
// MRE = 393.21 %
// WCE = 3320853
// WCRE = 81946300 %
// EP = 100.0 %
module mul12x12_269(A, B, O);
  input [11:0] A, B;
  output [23:0] O;
  wire n_2032, n_2027, n_36, n_42, n_1859, n_37, n_23, n_22, n_21, n_20;
  wire n_27, n_26, n_25, n_24, n_29, n_28, n_49, n_48, n_1778, n_1779;
  wire n_1938, n_801, n_87, n_86, n_89, n_88, n_200, n_201, n_1692, n_1946;
  wire n_39, n_1858, n_38, n_8, n_9, n_800, n_2040, n_4, n_5, n_6;
  wire n_7, n_0, n_1, n_2, n_3, n_30, n_31, n_32, n_33, n_34;
  wire n_35, n_18, n_19, n_16, n_17, n_14, n_15, n_12, n_13, n_10;
  wire n_11, n_45, n_2041, n_2026, n_44, n_43, n_51, n_47, n_1866, n_1867;
  wire n_1693, n_46, n_1952, n_41, n_2033, n_50, n_40;
  assign n_0 = A[0];
  assign n_1 = A[0];
  assign n_2 = A[1];
  assign n_3 = A[1];
  assign n_4 = A[2];
  assign n_5 = A[2];
  assign n_6 = A[3];
  assign n_7 = A[3];
  assign n_8 = A[4];
  assign n_9 = A[4];
  assign n_10 = A[5];
  assign n_11 = A[5];
  assign n_12 = A[6];
  assign n_13 = A[6];
  assign n_14 = A[7];
  assign n_15 = A[7];
  assign n_16 = A[8];
  assign n_17 = A[8];
  assign n_18 = A[9];
  assign n_19 = A[9];
  assign n_20 = A[10];
  assign n_21 = A[10];
  assign n_22 = A[11];
  assign n_23 = A[11];
  assign n_24 = B[0];
  assign n_25 = B[0];
  assign n_26 = B[1];
  assign n_27 = B[1];
  assign n_28 = B[2];
  assign n_29 = B[2];
  assign n_30 = B[3];
  assign n_31 = B[3];
  assign n_32 = B[4];
  assign n_33 = B[4];
  assign n_34 = B[5];
  assign n_35 = B[5];
  assign n_36 = B[6];
  assign n_37 = B[6];
  assign n_38 = B[7];
  assign n_39 = B[7];
  assign n_40 = B[8];
  assign n_41 = B[8];
  assign n_42 = B[9];
  assign n_43 = B[9];
  assign n_44 = B[10];
  assign n_45 = B[10];
  assign n_46 = B[11];
  assign n_47 = B[11];
  assign n_48 = ~(n_18 | n_12 | n_0);
  assign n_49 = n_48;
  assign n_50 = ~(n_49 & n_12);
  assign n_51 = n_50;
  assign n_86 = ~n_51;
  assign n_87 = n_86;
  assign n_88 = ~(n_2 & n_86);
  assign n_89 = n_88;
  assign n_200 = ~n_89;
  assign n_201 = n_200;
  assign n_800 = ~n_201;
  assign n_801 = n_800;
  assign n_1692 = n_201;
  assign n_1693 = n_1692;
  assign n_1778 = n_22 & n_44;
  assign n_1779 = n_1778;
  assign n_1858 = n_1779 & n_20;
  assign n_1859 = n_1858;
  FAX1 tmp77(.YS(n_1866), .YC(n_1867), .A(n_1693), .B(n_1778), .C(n_1859));
  assign n_1938 = n_18 & n_46;
  assign n_1946 = n_20 & n_46;
  assign n_1952 = n_22 & n_46;
  HAX1 tmp81(.YS(n_2026), .YC(n_2027), .A(n_46), .B(n_1938));
  FAX1 tmp82(.YS(n_2032), .YC(n_2033), .A(n_1866), .B(n_1946), .C(n_2027));
  FAX1 tmp83(.YS(n_2040), .YC(n_2041), .A(n_1867), .B(n_1952), .C(n_2033));
  assign O[0] = n_34;
  assign O[1] = n_28;
  assign O[2] = n_38;
  assign O[3] = n_88;
  assign O[4] = n_42;
  assign O[5] = n_20;
  assign O[6] = n_30;
  assign O[7] = n_8;
  assign O[8] = n_801;
  assign O[9] = n_12;
  assign O[10] = n_22;
  assign O[11] = n_32;
  assign O[12] = n_26;
  assign O[13] = n_4;
  assign O[14] = n_87;
  assign O[15] = n_24;
  assign O[16] = n_18;
  assign O[17] = n_86;
  assign O[18] = n_51;
  assign O[19] = n_800;
  assign O[20] = n_2026;
  assign O[21] = n_2032;
  assign O[22] = n_2040;
  assign O[23] = n_2041;
endmodule